﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using Telerik.Windows.Controls.ChartView;
using Telerik.Charting;
using Telerik.Windows.Controls;
using System.Windows.Threading;

namespace WPFApp
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private DispatcherTimer timer = new DispatcherTimer();

        bool hasTimerStarted = false;

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            double delay = 250;

            if (!hasTimerStarted)
            {                
                this.timer.Interval = TimeSpan.FromMilliseconds(delay);
                this.timer.Tick += this.OnTimer;
                this.timer.Start();
                hasTimerStarted = true;
            }
            else 
            {
                this.timer.Stop();
                this.timer.Tick -= this.OnTimer;
                hasTimerStarted = false;
            }
        }

        private void OnTimer(object sender, EventArgs e)
        {
            double msDelay = 250;
            (this.DataContext as ViewModel).AddDataItem(msDelay);
        }
    }

    public class ViewModel
    {
        public ObservableCollection<PlotInfo> Data { get; set; }

        public DateTime LastDate { get; set; }

        public ViewModel()
        {
            this.LastDate = DateTime.Today;

            this.Data = GetInitialData(5, 250);            
        }
        public ObservableCollection<PlotInfo> GetInitialData(int dataSize, double msDelay)
        {
            var result = new ObservableCollection<PlotInfo>();

            for (int i = 0; i < dataSize; i++)
            {
                result.Add(new PlotInfo { Date = LastDate, YVal = rnd.Next(5, 100) });

                this.LastDate = this.LastDate.AddMilliseconds(msDelay);
            }

            return result;
        }

        public void AddDataItem(double msDelay)
        {
            this.Data.Add(new PlotInfo { Date = LastDate, YVal = rnd.Next(5, 100)});
            this.LastDate = this.LastDate.AddMilliseconds(msDelay);
        }

        private static readonly Random rnd = new Random();
    }

    public class PlotInfo
    {
        public DateTime Date { get; set; }
        public double YVal { get; set; }
    }
}
